/*-
 * This file is a part of the MDCacheD server
 * (c) 2007.-2011. Ivan Voras <ivoras@gmail.com>
 * Released under the 2-clause BSDL
 * $Id: ServerNetworkThread.h 449 2012-03-20 14:39:42Z ivoras $
 */

#ifndef _SERVER_NETWORK_THREAD_H_
#define _SERVER_NETWORK_THREAD_H_

#include "Thread.h"

extern ServerWorkerThread *worker_threads;
extern unsigned int n_worker_threads;

class ServerNetworkThread : public Thread {
public:
#ifndef NDEBUG
	struct debug_status_record 	st;
#endif
	unsigned			index;
	ServerNetworkThread();
	~ServerNetworkThread();
	virtual void run();

	ServerWorkerThread *getWorkerThread() {
		return &worker_threads[rr_worker_thread];
	}

	void rollWorkerThread() {
		rr_worker_thread++;
		if (rr_worker_thread >= n_worker_threads)
			rr_worker_thread = 0;
	}

	void setWorkerIndex(unsigned int i) {
		rr_worker_thread = i;
	}

	int evqAdd(ev_list ev, unsigned int len) {
		return ev_enqueue_list(evq, ev, len);
	}

	ev_queue *getEvq() {
		return &evq;
	}

private:
	ev_queue		evq;	/* event queue for conns sockets */
	pthread_mutex_t		evq_mtx;
	pthread_cond_t		evq_cv;
	unsigned int		rr_worker_thread;
};

#endif
