dnl $Id: config.m4,v 1.3 2008-07-06 22:56:58 ivoras Exp $
dnl config.m4 for extension mdcached

dnl Comments in this file start with the string 'dnl'.
dnl Remove where necessary. This file will not work
dnl without editing.

dnl If your extension references something external, use with:

dnl PHP_ARG_WITH(mdcached, for mdcached support,
dnl Make sure that the comment is aligned:
dnl [  --with-mdcached             Include mdcached support])

dnl Otherwise use enable:

PHP_ARG_ENABLE(mdcached, whether to enable mdcached support,
[  --enable-mdcached           Enable mdcached support])

if test "$PHP_MDCACHED" != "no"; then
  dnl Write more examples of tests here...

  dnl # --with-mdcached -> check with-path
  SEARCH_PATH="/usr/local /usr"
  SEARCH_FOR="/include/mc_client.h"
  if test -r $PHP_MDCACHED/$SEARCH_FOR; then
    MDCACHED_DIR=$PHP_MDCACHED
  else
    AC_MSG_CHECKING([for mdcached files in default path])
    for i in $SEARCH_PATH ; do
      if test -r $i/$SEARCH_FOR; then
        MDCACHED_DIR=$i
        AC_MSG_RESULT(found in $i)
      fi
    done
  fi
  
  if test -z "$MDCACHED_DIR"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Please reinstall the mdcached client library])
  fi

  dnl # --with-mdcached -> add include path
  PHP_ADD_INCLUDE($MDCACHED_DIR/include)

  dnl # --with-mdcached -> check for lib and symbol presence
  LIBNAME=mdcached
  LIBSYMBOL=mc_connect_local

  PHP_CHECK_LIBRARY($LIBNAME, $LIBSYMBOL,
  [
     PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $MDCACHED_DIR/lib, MDCACHED_SHARED_LIBADD)
     AC_DEFINE(HAVE_MDCACHEDLIB,1,[ ])
  ],[
     AC_MSG_ERROR([wrong mdcached lib version or lib not found])
  ],[
     -L$MDCACHED_DIR/lib -lm -lmdcached -g
  ])
  
  PHP_SUBST(MDCACHED_SHARED_LIBADD)

  PHP_NEW_EXTENSION(mdcached, mdcached.c, $ext_shared)
fi
