<?php
/*-
 * (c) 2008-2011. Ivan Voras <ivoras@gmail.com>
 * Licensed under the PHP license.
 */

/* The minimum possible usage of mdcached */

$mc = mc_connect_local(MC_DEFAULT_UNIX_SOCKET);
mc_perform_handshake($mc); // optional

mc_put_simple($mc, "somekey", "some value stored in the cache");
echo mc_get_simple($mc, "somekey") . "#\n";

mc_put_simple_tags($mc, "key2", "a tagged record value", array(1=>2, 2=>3), 10);
echo mc_get_simple($mc, "key2") . "#\n";

mc_put_simple_tags($mc, "tagged", "another tagged record value", array(2=>100));

var_dump(mc_get_by_tag_values($mc, 1, array(2)));
var_dump(mc_del_by_tag_values($mc, 1, array(2)));
var_dump(mc_get_simple($mc, "key2"));

mc_mput($mc, array('k1' => 'v', 'k2' => 'vv', 'k3' => 'vvv'), 0, 0, array(2=>200));

echo "mc_get_by_tag_values:\n";
var_dump(mc_get_by_tag_values($mc, 2, array(100, 200)));
var_dump(mc_mget($mc, array('k2', 'tagged', 'k3')));
var_dump(mc_get_all_keys($mc));

echo mc_tstack_push($mc, "record1", array(50 => 50)) . "\n";
echo mc_tstack_push($mc, "record2", array(50 => 50)) . "\n";
while ($r = mc_tstack_pop($mc, 50, 50))
    var_dump($r);

mc_atomic_add($mc, "atomic0", 1);
echo mc_atomic_get($mc, "atomic0") . ' -> ';
mc_atomic_add($mc, "atomic0", 1);
echo mc_atomic_get($mc, "atomic0") . "\n";

mc_atomic_put($mc, "atomic1", 100, array(10=>20));
echo mc_atomic_get($mc, "atomic1") . ' -> ';
mc_atomic_add($mc, "atomic1", 10);
echo mc_atomic_get($mc, "atomic1") . "\n";

var_dump(mc_get_simple_tags($mc, "atomic1"));
mc_set_tags($mc, "atomic1", array(1024=>1025, 2=>3));
var_dump(mc_get_simple_tags($mc, "atomic1"));


