#include "MurmurHash2.h"
#include <stdio.h>
#include "hash.h"
#include <sys/time.h>

double now() {
	struct timeval tv;

	gettimeofday(&tv, NULL);
	return tv.tv_sec + tv.tv_usec / 1000000.0;
}

#define NL 10000000

int main() {
	int i, j;
	double t1, t2;

	printf("%x\n", MurmurHash2("abcde", 5, 0xa00aaffa));
	printf("%x\n", MurmurHash2("abcdef", 6, 0xa00aaffa));
	printf("%x\n\n", MurmurHash2("abcdefg", 7, 0xa00aaffa));

	printf("%x\n", hash32_buf("abcde", 5));
	printf("%x\n", hash32_buf("abcdef", 6));
	printf("%x\n", hash32_buf("abcdefg", 7));

	t1 = now();
	for (i = 0; i < NL; i++) {
		j += MurmurHash2("abcde", 5, 0xa00aaffa);
		j += MurmurHash2("abcdef", 6, 0xa00aaffa);
		j += MurmurHash2("abcdefg", 7, 0xa00aaffa);
		j += MurmurHash2("abcdefgh", 8, 0xa00aaffa);
	}
	t2 = now();
	printf("MurmurHash2:\t%0.2lf\n", t2-t1);

	t1 = now();
	for (i = 0; i < NL; i++) {
		j += hash32_buf("abcde", 5);
		j += hash32_buf("abcdef", 6);
		j += hash32_buf("abcdefg", 7);
		j += hash32_buf("abcdefgh", 8);
	}
	t2 = now();
	printf("djb2:\t\t%0.2lf\n", t2-t1);
}
