#include <stdlib.h>
#include <stdio.h>

#include "cqueue.h"

/* cqueue regression test */

struct bag {
	int holding;
};

CQUEUE_DECLARE(bag);

void dump_cq(CQUEUE(bag) *cq)
{
	int i;
	printf("first=%2d, last=%2d, size=%2d\n", cq->first, cq->last, cq->size);
	for (i = 0; i < cq->size; i++)
		printf("%2d ", cq->items[i].holding);
	printf("\n");
}

int main()
{
	int i;
	CQUEUE(bag) cq;
	struct bag *e;
	
	CQUEUE_CREATE(bag, &cq);	
	printf("struct size=%d, *items size=%d\n", sizeof(struct bag), sizeof(cq.items[0]));
	
	/* Simple ADD */
	for (i = 0; i < 5; i++) {
		e = CQUEUE_ADD(bag, &cq);
		e->holding = i+1;
	}
	while ( (e = CQUEUE_GET(bag, &cq)) != NULL)
		printf("%d\t", e->holding);
	printf("\n");
	
	/* ADD that extends the queue */
	for (i = 0; i < 5+CQUEUE_INITIAL_SIZE; i++) {
		e = CQUEUE_ADD(bag, &cq);
		e->holding = i+1;
	}
	while ( (e = CQUEUE_GET(bag, &cq)) != NULL)
		printf("%d\t", e->holding);
	printf("\n");
	
	CQUEUE_DESTROY(&cq);
	CQUEUE_CREATE(bag, &cq);
	for (i = 0; i < CQUEUE_INITIAL_SIZE; i++) {
		e = CQUEUE_ADD(bag, &cq);
		e->holding = i+1;
		e = CQUEUE_GET(bag, &cq);
		if (e->holding != i+1)
			abort();
		else
			printf("%d\t", e->holding);
	}
	printf("\n");
	
	return 0;
}
