#ifdef __linux__
#define __USE_UNIX98
#endif

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <paths.h>
#include <syslog.h>
#include <assert.h>
#include <err.h>

#ifdef DMALLOC
#include <dmalloc.h>
#endif

#if __FreeBSD__ >= 7
#include <pthread_np.h>
#define HAS_PTHREAD_SET_NAME_NP
#endif

#include "queue.h"
#include "tree.h"

#include "server.h"
#include "mc_protocol.h"
#include "data_storage.h"
#include "logger.h"

int argc;
char **argv;

static void show_help() {
	printf("usage: %s [-h]\n", argv[0]);
}


int main(int _argc, char **_argv) {
	int ch;
	
	argc = _argc;
	argv = _argv;
	
	while ((ch = getopt(argc, argv, "h")) != -1) {
		switch (ch) {
		case 'h':
			show_help();
			exit(0);
			break;
	}
	
}
